343. 整数拆分


题目:

343. 整数拆分

给定一个正整数 n ,将其拆分为 k 个 正整数 的和( k >= 2 ),并使这些整数的乘积最大化。

返回 你可以获得的最大乘积 。

示例 1:

复制代码
输入: n = 2
输出: 1
解释: 2 = 1 + 1, 1 × 1 = 1。

示例 2:

复制代码
输入: n = 10
输出: 36
解释: 10 = 3 + 3 + 4, 3 × 3 × 4 = 36。

提示:

  • 2 <= n <= 58

思考历程与知识点:

看到这道题目,都会想拆成两个呢,还是三个呢,还是四个....

我们来看一下如何使用动规来解决。

动规五部曲,分析如下:

  1. 确定dp数组(dp table)以及下标的含义

dpi:分拆数字i,可以得到的最大乘积为dpi。

dpi的定义将贯彻整个解题过程,下面哪一步想不懂了,就想想dpi究竟表示的是啥!

2.确定递推公式

可以想 dpi最大乘积是怎么得到的呢?

其实可以从1遍历j,然后有两种渠道得到dpi.

一个是j * (i - j) 直接相乘。

一个是j * dpi - j,相当于是拆分(i - j),对这个拆分不理解的话,可以回想dp数组的定义。

那有同学问了,j怎么就不拆分呢?

j是从1开始遍历,拆分j的情况,在遍历j的过程中其实都计算过了。那么从1遍历j,比较(i - j) * j和dpi - j * j 取最大的。递推公式:dpi = max(dpi, max((i - j) * j, dpi - j * j));

也可以这么理解,j * (i - j) 是单纯的把整数拆分为两个数相乘,而j * dpi - j是拆分成两个以及两个以上的个数相乘。

如果定义dpi - j * dpj 也是默认将一个数强制拆成4份以及4份以上了。

所以递推公式:dpi = max({dpi, (i - j) * j, dpi - j * j});

那么在取最大值的时候,为什么还要比较dpi呢?

因为在递推公式推导的过程中,每次计算dpi,取最大的而已。

3.dp的初始化

不少同学应该疑惑,dp0 dp1应该初始化多少呢?

有的题解里会给出dp0 = 1,dp1 = 1的初始化,但解释比较牵强,主要还是因为这么初始化可以把题目过了。

严格从dpi的定义来说,dp0 dp1 就不应该初始化,也就是没有意义的数值。

拆分0和拆分1的最大乘积是多少?

这是无解的。

这里我只初始化dp2 = 1,从dpi的定义来说,拆分数字2,得到的最大乘积是1,这个没有任何异议!

4.确定遍历顺序

确定遍历顺序,先来看看递归公式:dpi = max(dpi, max((i - j) * j, dpi - j * j));

dpi 是依靠 dpi - j的状态,所以遍历i一定是从前向后遍历,先有dpi - j再有dpi。

所以遍历顺序为:

cpp 复制代码
for (int i = 3; i <= n ; i++) {
    for (int j = 1; j < i - 1; j++) {
        dp[i] = max(dp[i], max((i - j) * j, dp[i - j] * j));
    }
}

注意 枚举j的时候,是从1开始的。从0开始的话,那么让拆分一个数拆个0,求最大乘积就没有意义了。

j的结束条件是 j < i - 1 ,其实 j < i 也是可以的,不过可以节省一步,例如让j = i - 1,的话,其实在 j = 1的时候,这一步就已经拆出来了,重复计算,所以 j < i - 1

至于 i是从3开始,这样dpi - j就是dp2正好可以通过我们初始化的数值求出来。

更优化一步,可以这样:

cpp 复制代码
for (int i = 3; i <= n ; i++) {
    for (int j = 1; j <= i / 2; j++) {
        dp[i] = max(dp[i], max((i - j) * j, dp[i - j] * j));
    }
}

因为拆分一个数n 使之乘积最大,那么一定是拆分成m个近似相同的子数相乘才是最大的。

例如 6 拆成 3 * 3, 10 拆成 3 * 3 * 4。 100的话 也是拆成m个近似数组的子数 相乘才是最大的。

只不过我们不知道m究竟是多少而已,但可以明确的是m一定大于等于2,既然m大于等于2,也就是 最差也应该是拆成两个相同的 可能是最大值。

那么 j 遍历,只需要遍历到 n/2 就可以,后面就没有必要遍历了,一定不是最大值。

至于 "拆分一个数n 使之乘积最大,那么一定是拆分成m个近似相同的子数相乘才是最大的" 这个我就不去做数学证明了,感兴趣的同学,可以自己证明。

之后举例推导dp数组就可以了


题解:

cpp 复制代码
class Solution {
public:
    int integerBreak(int n) {
        vector<int> dp(n + 1);
        dp[2] = 1;
        for (int i = 3; i <= n ; i++) {
            for (int j = 1; j <= i / 2; j++) {
                dp[i] = max(dp[i], max((i - j) * j, dp[i - j] * j));
            }
        }
        return dp[n];
    }
};

欢迎点赞,收藏,评论,你的鼓励就是我创作的最大动力!(๑╹◡╹)ノ"""

版权声明:本文为CSDN博主「渡梦酒」的原创文章,遵循CC 4.0 BY-SA版权协议,转载请附上原文出处链接及本声明。

原文链接:渡梦酒的博客_CSDN博客-csdn领域博主

相关推荐
小郎君6581 小时前
MPTT树复选框的半选状态:一棵百万节点树从递归到计数器,再到区间覆盖
算法
酌沧1 小时前
MemT让记忆成为模型内生能力
jvm·人工智能·算法
Shimeri2 小时前
越卷越像:我用遗传算法做了个"内卷"实验
算法·three.js·数据可视化·遗传算法·进化算法
Evand J2 小时前
【PMSM例程1】永磁同步电机(PMSM)转速与转子电角度观测算法|基于扩展卡尔曼滤波(EKF)的传感器状态估计与误差。附下载链接
算法·电机·1024程序员节·卡尔曼滤波
guo_wen_qiang2 小时前
二叉树的层序遍历-使用双端队列Deque
算法·leetcode·1024程序员节
爱读书的小胖3 小时前
LeetCode 55 跳跃游戏 C 语言解题分析
c语言·数据结构·算法·leetcode·1024程序员节
CCblandy3 小时前
前缀缓存命中率不靠引擎靠排列:本机仿真 3 轮,易变字段放开头 98.0%→0.0%
人工智能·python·算法·自然语言处理·性能优化
上班摸鱼下班游戏3 小时前
Unity 仿生智能算法 从蚁群算法 开始
算法·unity·游戏引擎
pipixia200333 小时前
C++ 面试高频:namespace 的 6 个知识点,从 using 到匿名命名空间
c语言·学习·算法·嵌入式·命名空间·c++面试·匿名命名空间
Navigator_Z4 小时前
LeetCode //C - 1300. Sum of Mutated Array Closest to Target
c语言·算法·leetcode